// *********************************************************************
//  Created with bc9Basic - BASIC To C/C++ Translator (V) 9.2.5.9 (2017/01/27)
//       The bc9Basic translator (bc9.exe) was compiled with
//                           g++ (tdm64-1) 5.1.0
// ----------------------------------------------------------------------
//                 BCX (c) 1999 - 2009 by Kevin Diggins
// *********************************************************************
//              Translated for compiling with the
//           Microsoft (R) C/C++ Optimizing Compiler
//                           On MS Windows
//                    Using TCLib by Fred Harris
// *********************************************************************
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _UNICODE
#define _UNICODE
#endif
#define _X(y) y
#include <windows.h>
#define   x64
#include "TCLib\stdio.h"
#include "TCLib\string.h"
#include "TCLib\stdlib.h"
#include "TCLib\memory.h"
#include "TCLib\malloc.h"
#include "TCLib\math.h"
#include "TCLib\tchar.h"
#include "TCLib\Strings.cpp"
typedef String fstring;
FILE* stdin;
FILE* stdout;
FILE* stderr;
//<---UNICODE AWARE
#define SFMT (const char*)"%s\r\n"
//>---UNICODE AWARE

// NO HEADERS START
#ifndef _WINDOWS_
//<---UNICODE AWARE
typedef _TCHAR *PCHAR, *LPCH, *PCH, *NPSTR, *LPSTR, *PSTR;
typedef unsigned long DWORD, *PDWORD, *LPDWORD;
typedef unsigned int UINT;
//>---UNICODE AWARE
#endif
// NO HEADERS END
// ***************************************************
// Compiler Defines
// ***************************************************
#ifndef __cplusplus
#error A C++ compiler is required
#endif
// $HEADER BEGIN
#pragma comment(lib,"ole32.lib")
#pragma comment(lib,"OleAut32.lib")
// $HEADER END


// *************************************************
//        User's GLOBAL ENUM blocks
// *************************************************

typedef enum _CompareMethod
{
    BinaryCompare,
    TextCompare,
    DatabaseCompare
} CompareMethod;


// *************************************************
//            System Defined Constants
// *************************************************

typedef const _TCHAR* ccptr;
#define CCPTR const _TCHAR*
#define cfree free
//<---UNICODE AWARE
typedef char _char;
#define _strlen strlen
//>---UNICODE AWARE
#define EQU ==
#define NOT_USED(x) if(x);
#define CTLHNDL(id) GetDlgItem(hWnd,id)
#define cSizeOfDefaultString 2048

// *************************************************
//            User Defined Constants
// *************************************************

#define c_SglQt 39
#define c_DblQt 34
#define c_LPar 40
#define c_RPar 41
#define c_Komma 44
#define c_LtBkt 91
#define c_RtBkt 93

// *************************************************
//               Standard Prototypes
// *************************************************

int     str_cmp(const _TCHAR*, const _TCHAR*);
_TCHAR*   BCX_TmpStr(size_t, size_t = 0, int = 1);
_TCHAR*   ucase (const _TCHAR*);
_TCHAR*   _strupr_(_TCHAR *);
_TCHAR*   _strlwr_(_TCHAR *);
void    Pause (void);
float   timer (void);

// *************************************************
//                System Variables
// *************************************************

static _TCHAR    NUL [1] = {0};   // Null
// *************************************************
//          User Defined Types, Unions and Classes
// *************************************************


interface IDictionary:
public IDispatch
{
public:
    virtual HRESULT   putref_Item(VARIANT*, VARIANT*) = 0;
    virtual HRESULT   put_Item(VARIANT*, VARIANT*) = 0;
    virtual HRESULT   get_Item(VARIANT*, VARIANT*) = 0;
    virtual HRESULT   Add(VARIANT*, VARIANT*) = 0;
    virtual HRESULT   get_Count(long*) = 0;
    virtual HRESULT   Exists(VARIANT*, VARIANT_BOOL*) = 0;
    virtual HRESULT   Items(VARIANT*) = 0;
    virtual HRESULT   put_Key(VARIANT*, VARIANT*) = 0;
    virtual HRESULT   Keys(VARIANT*) = 0;
    virtual HRESULT   _Remove(VARIANT*) = 0;
    virtual HRESULT   RemoveAll(void) = 0;
    virtual HRESULT   put_CompareMode(CompareMethod) = 0;
    virtual HRESULT   get_CompareMode(CompareMethod*) = 0;
    virtual HRESULT   _NewEnum(IUnknown**) = 0;
    virtual HRESULT   get_HashVal(VARIANT*, VARIANT*) = 0;
};


class cBcxDic
{
public:
    cBcxDic(void);
    ~cBcxDic(void);
    BOOL   Add(_TCHAR*, _TCHAR*);
    BOOL   Add(int, _TCHAR*);
    BOOL   Add(VARIANT*, VARIANT*);
    BOOL   put_item(_TCHAR*, _TCHAR*);
    BOOL   put_item(long, _TCHAR*);
    _TCHAR*   get_item(_TCHAR*);
    _TCHAR*   get_item(long);
    long   get_count(void);
    BOOL   Exists(_TCHAR*);
    BOOL   Exists(long);
    BOOL   put_key(_TCHAR*, _TCHAR*);
    BOOL   put_key(long, _TCHAR*);
    BOOL   _Remove(_TCHAR*);
    BOOL   _Remove(long);
    BOOL   RemoveAll(void);
    BOOL   put_CompareMode(CompareMethod);
    CompareMethod   get_CompareMode(void);

protected:
    IDictionary*  m_oDict;
};


class CVariant: public VARIANT
{
public:
    CVariant(void);
    CVariant(VARIANT_BOOL);
    CVariant(int);
    CVariant(long);
    CVariant(double);
    CVariant(_TCHAR*);
    CVariant(VARIANT*);
    CVariant(int, int);
    ~CVariant(void);
    BOOL   IsArray(int = 0 );
    BOOL   IsString(int = 0 );
    BOOL   IsInt(int = 0 );
    BOOL   IsBool(int = 0 );
    VARIANT*   operator&(void);
    VARIANT*   ElementAt(int = 0 );
    _TCHAR*   ToString(int = 0 );
    int   ToInt(int = 0 );
    BOOL   ToBool(int = 0 );
    void   Set(_TCHAR*, int = 0 );
    void   Set(int, int = 0 );
    void   Set(VARIANT_BOOL, int = 0 );
};


// *************************************************
//            User Global Variables
// *************************************************



// *************************************************
//              User Data Statements
// *************************************************

const _TCHAR * DATA [] =
{
    _T("IF"), _T("THEN"), _T("ELSE"), _T("TRY"), _T("CATCH"), _T("END"), _T("SELECT"), _T("CASE"), _T("FUNCTION"), _T("SUB"), _T("ITERATE"), _T("FOR"), _T("NEXT"), _T("WHILE"), _T("UNTIL"), _T("DO"), _T("LOOP"), _T("WEND"), _T("STEP"),
    _T("EXIT"), _T("REGISTER"), _T("LOCAL"), _T("GLOBAL"), _T("STATIC"), _T("INCR"), _T("DECR"), _T("BY"), _T("DATA"), _T("OPT"), _T("OPTIONAL"), _T("CONST"), _T("SLEEP"), _T("RESOURCE"), _T("OBJECT"), _T("IMAGE"), _T("SWAP"),
    _T("AS"), _T("TO"), _T("GOTO"), _T("STDOUT"), _T("PRINT"), _T("PRINTR"), _T("PRINTBR"), _T("ECHO"), _T("DIM"), _T("REDIM"), _T("BYVAL"), _T("BYREF"), _T("BYCOPY"), _T("TYPE"), _T("TABLE"), _T("ENTRY"), _T("LANGUAGE"), _T("NAME"),
    _T("MACRO"), _T("EXPORT"), _T("REPLACE"), _T("WITH"), _T("IN"), _T("GOSUB"), _T("RETURN"), _T("ENDIF"), _T("MACROTEMP"), _T("ELSEIF"), _T("YES"), _T("NO"), _T("ON"), _T("OFF"), _T("REGISTER"), _T("SYSTEM"), _T("ARR"), _T("INFINITE"),
    _T("ASCEND"), _T("DESCEND"), _T("TAGARRAY"), _T("COLLATE"), _T("FROM"), _T("SCAN"), _T("INSERT"), _T("DELETE"), _T("VARIANT"), _T("TCP"), _T("PORT"), _T("AT"), _T("SEND"), _T("RECV"), _T("TIMEOUT"), _T("ALIAS"), _T("LIB"),
    _T("DECLARE"), _T("DEF"), _T("ERRORS"), _T("PLURIBASIC"), _T("WARNINGS"), _T("NOTICES"), _T("DEPRECATED"), _T("PARSES"), _T("ALL"), _T("NONE"), _T("ANY"), _T("EXACT"), _T("ITERATE"), _T("PHP"), _T("HTML"), _T("START"),
    _T("MYSQL"), _T("LOAD"), _T("SAVE"), _T("DELETE"), _T("WHERE"), _T("LIMITUDT"), _T("PBCC"), _T("PBWIN"), _T("USEUNICODE"), _T("CRACKERS"), _T("SESSTART"), _T("EXCLUSIVE"), _T("AUTO"), _T("OPEN"), _T("CLOSE"), _T("CLOSED"),
    _T("APPEND"), _T("INPUT"), _T("OUTPUT"), _T("SETEOF"), _T("SEEK"), _T("GET"), _T("PUT"), _T("PRINT"), _T("FOREACH"), _T("ACCESS"), _T("READ"), _T("WRITE"), _T("SHARED"), _T("LOCK"), _T("SEEK"), _T("LINE"), _T("CALL"), _T("BITWISE"),
    _T("LOGICAL"), _T("UDT"), _T("QUIT"), _T("ABORT"), _T("TERMINATE"), _T("DECLARE"), _T("CLASS"), _T("METHOD"), _T("PROPERTY"), _T("CREATE"), _T("DESTROY"), _T("INSTANCE"), _T("GET"), _T("SET"), _T("INTERFACE"), _T("LET"),
    _T("CREATE"), _T("DESTROY"), _T("WAITKEY$"), _T("RESET"), _T("RESERVE"), _T("DEFBYT"), _T("DEFDWD"), _T("DEFINT"), _T("DEFLNG"), _T("DEFSNG"), _T("DEFSTR"), _T("DEFWRD"), _T("DEFASC"), _T("BINARY"),
    _T("ISCOND"), _T("NOTNULL"), _T("AUTOINC"), _T("PRIMARY"), _T("ON"), _T("OFF"), _T("YES"), _T("NO"), _T("EXE"), _T("PHP"), _T("DLL"), _T("SLL"), _T("CONSOLE"), _T("EXCLUDE"), _T("INCLUDE"), _T("RAW"),
    _T("VARPTR"), _T("LBOUND"), _T("UBOUND"), _T("SYS_ARR"), _T("SYS_IMG"),
    _T("IIF"), _T("CHOOSE"), _T("CHOOSES"), _T("CHOOSEI"), _T("CHOOSED"), _T("CHOOSEF"), _T("CHOOSEB"), _T("USING"), _T("EOD")
};

// *************************************************
//               User Prototypes
// *************************************************

int     IsReservedWord (cBcxDic&, const _TCHAR*);
int     _tmain (void);

// *************************************************
//            User Global Initialized Arrays
// *************************************************

static const CLSID   CLSID_Dictionary = {0xEE09B103, 0x97E0, 0x11CF, {0x97, 0x8F, 0x00, 0xA0, 0x24, 0x63, 0xE0, 0x6F}};
static const IID     IID_IDictionary = {0x42C642C1, 0x97E1, 0x11CF, {0x97, 0x8F, 0x00, 0xA0, 0x24, 0x63, 0xE0, 0x6F}};


// *************************************************
//                 Runtime Functions
// *************************************************

#ifndef BCXTmpStrSize
#define BCXTmpStrSize  2048
#endif
_TCHAR *BCX_TmpStr (size_t Bites, size_t  iPad, int iAlloc)
{
    static int   StrCnt;
    static _TCHAR *StrFunc[BCXTmpStrSize];
    StrCnt = (StrCnt + 1) & (BCXTmpStrSize - 1);
    if(StrFunc[StrCnt]) {
        free (StrFunc[StrCnt]);
        StrFunc[StrCnt] = NULL;
    }
#if defined BCX_MAX_VAR_SIZE
    if(Bites * sizeof(_TCHAR) > BCX_MAX_VAR_SIZE)
    {
        _tprintf(_T("Buffer Overflow caught in BCX_TmpStr - requested space of %d EXCEEDS %d\n"), (int)(Bites * sizeof(_TCHAR)), BCX_MAX_VAR_SIZE);
        abort();
    }
#endif
    if(iAlloc) StrFunc[StrCnt] = (_TCHAR*)calloc(Bites + iPad + 1, sizeof(_TCHAR));
    return StrFunc[StrCnt];
}


int str_cmp (const _TCHAR *a, const _TCHAR *b)
{
    int counter = 0;
    for(;;)
    {
        if((a[counter]^b[counter]))
        {
            if((UINT) a[counter] >= (UINT) b[counter])
                return  1;
            return -1;
        }
        if(!a[counter]) return 0;
        counter++;
    }
}


_TCHAR *ucase (const _TCHAR *S)
{
    _TCHAR *strtmp = BCX_TmpStr(_tcslen(S), 1, 1);
    return _strupr_(_tcscpy(strtmp, (_TCHAR*)S));
}


void Pause(void)
{
    _tprintf(_T("\n%ls\n"), _T("Press any key to continue..."));
    _getwch();
}


float timer (void)
{
    return (GetTickCount() / 1000.0);
}


_TCHAR *_strupr_(_TCHAR *string)
{
    _TCHAR *s;

    if (string)
    {
        for(s = string; *s; ++s)
            *s = towupper(*s);
    }
    return string;
}

_TCHAR *_strlwr_(_TCHAR *string)
{
    _TCHAR *s;

    if (string)
    {
        for (s = string; *s; ++s)
            *s = towlower(*s);
    }
    return string;
}



// *************************************************
//       User Subs, Functions and Class Methods
// *************************************************

cBcxDic::cBcxDic ()
{
    HRESULT  hr;
    hr = CoCreateInstance( CLSID_Dictionary, NULL, CLSCTX_INPROC_SERVER, IID_IDictionary, ( void**)& m_oDict);
}
cBcxDic::~cBcxDic ()
{
    m_oDict->Release();
}
BOOL cBcxDic::Add (_TCHAR* skey, _TCHAR* sitem)
{
    CVariant  v1;
    CVariant  v2;
    v1.Set(skey);
    v2.Set(sitem);
    m_oDict->Add( &v1, &v2);
    return 0;
}


BOOL cBcxDic::Add (int ikey, _TCHAR* sitem)
{
    CVariant  v1;
    CVariant  v2;
    v1.Set(ikey);
    v2.Set(sitem);
    m_oDict->Add( &v1, &v2);
    return 0;
}


long cBcxDic::get_count ()
{
    long     count;
    m_oDict->get_Count( &count);
    return count;
}


BOOL cBcxDic::Exists (_TCHAR* skey)
{
    CVariant  v1;
    VARIANT_BOOL  vb;
    v1.Set(skey);
    m_oDict->Exists( &v1, &vb);
    if(vb )
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}


BOOL cBcxDic::Exists (long skey)
{
    CVariant  v1;
    VARIANT_BOOL  vb;
    v1.Set(skey);
    m_oDict->Exists( &v1, &vb);
    if(vb )
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}


BOOL cBcxDic::put_item (_TCHAR* skey, _TCHAR* spretitem)
{
    CVariant  v1;
    CVariant  v2;
    v1.Set(skey);
    v2.Set(spretitem);
    m_oDict->put_Item( &v1, &v2);
    return 0;
}


BOOL cBcxDic::put_key (_TCHAR* skey, _TCHAR* rhs)
{
    CVariant  v1;
    CVariant  v2;
    v1.Set(skey);
    v2.Set(rhs);
    m_oDict->put_Key( &v1, &v2);
    return 0;
}


_TCHAR* cBcxDic::get_item (_TCHAR* skey)
{
    CVariant  v1;
    CVariant  v2;
    v1.Set(skey);
    m_oDict->get_Item( &v1, &v2);
    return v2.ToString();
}


_TCHAR* cBcxDic::get_item (long skey)
{
    CVariant  v1;
    CVariant  v2;
    v1.Set(skey);
    m_oDict->get_Item( &v1, &v2);
    return v2.ToString();
}


BOOL cBcxDic::_Remove (_TCHAR* skey)
{
    CVariant  v;
    HRESULT  hr;
    v.Set(skey);
    hr = m_oDict->_Remove(  &v);
    if(SUCCEEDED(hr))
    {
        return TRUE;
    }
    return FALSE;
}


VARIANT* CVariant::operator & ()
{
    return this;
}


CVariant::CVariant ()
{
    vt = VT_EMPTY;
}
CVariant::CVariant (VARIANT_BOOL  bValue)
{
    vt = VT_BOOL;
    bVal = bValue;
}
CVariant::CVariant (int iValue)
{
    vt = VT_I4;
    intVal = iValue;
}
CVariant::CVariant (long nValue)
{
    vt = VT_I4;
    lVal = nValue;
}
CVariant::CVariant (double dValue)
{
    vt = VT_R8;
    dblVal = dValue;
}
CVariant::CVariant (_TCHAR* szValue)
{
    if(_tcslen(szValue))
    {
        vt = VT_BSTR;
        bstrVal = SysAllocString( szValue);
    }
}
CVariant::CVariant (VARIANT* pV)
{
    vt = VT_VARIANT;
    pvarVal = pV;
}
CVariant::CVariant (int L_Bound, int iElementCount)
{
    vt = VT_ARRAY | VT_VARIANT;
    parray = new  SAFEARRAY;
    parray->cDims = 1;
    parray->fFeatures = FADF_VARIANT | FADF_HAVEVARTYPE | FADF_FIXEDSIZE | FADF_STATIC;
    parray->cbElements = sizeof( VARIANT);
    parray->cLocks = 0;
    parray->pvData = new  VARIANT[ iElementCount];
//<---UNICODE AWARE
    memset(parray->pvData, 0, sizeof(VARIANT)*iElementCount);
//>---UNICODE AWARE
    parray->rgsabound[0].lLbound    = L_Bound;
    parray->rgsabound[0].cElements    = iElementCount;
}
CVariant::~CVariant ()
{
    UINT     i;
    if(vt == VT_BSTR )
    {
        SysFreeString(bstrVal);
        goto L1000;
    }
    if(vt == VT_ARRAY || vt == VT_VARIANT )
    {
        for(i = 0; i <= parray->rgsabound[0].cElements - 1; i += 1)
        {
            if((((VARIANT*)parray->pvData)[i].vt == VT_BSTR))
            {
                SysFreeString(((VARIANT*)parray->pvData)[i].bstrVal);
            }
        }

        delete parray;
    }
L1000:
    ;
}
BOOL CVariant::IsArray (int iElement)
{
    VARIANT*  pV = ElementAt(iElement);
    VARTYPE  v;
    if((pV != (VARIANT*)NULL))
    {
        if((pV->vt == VT_VARIANT && pV->pvarVal != (VARIANT*)NULL))
        {
            v = pV->pvarVal->vt;
        }
        else
        {
            v = pV->vt;
        }
        return v & VT_ARRAY;
    }
    return FALSE;
}


BOOL CVariant::IsString (int iElement)
{
    VARIANT*  pV = ElementAt(iElement);
    VARTYPE  v;
    if((pV != (VARIANT*)NULL))
    {
        if((pV->vt == VT_VARIANT && pV->pvarVal != (VARIANT*)NULL))
        {
            v = pV->pvarVal->vt;
        }
        else
        {
            v = pV->vt;
        }
        return       v == VT_BSTR;
    }
    return FALSE;
}


BOOL CVariant::IsInt (int iElement)
{
    VARIANT*  pV = ElementAt(iElement);
    VARTYPE  v;
    if((pV != (VARIANT*)NULL))
    {
        if((pV->vt == VT_VARIANT && pV->pvarVal != (VARIANT*)NULL))
        {
            v = pV->pvarVal->vt;
        }
        else
        {
            v = pV->vt;
        }
        if(v == VT_I1 || v == VT_I2 || v == VT_I4 )
        {
            return TRUE;
        }
        else // case else
        {
            return FALSE;
        }
    }
    return FALSE;
}


BOOL CVariant::IsBool (int iElement)
{
    VARIANT*  pV = ElementAt(iElement);
    VARTYPE  v;
    if((pV != (VARIANT*)NULL))
    {
        if((pV->vt == VT_VARIANT && pV->pvarVal != (VARIANT*)NULL))
        {
            v = pV->pvarVal->vt;
        }
        else
        {
            v = pV->vt;
        }
        return       v == VT_BOOL;
    }
    return FALSE;
}


VARIANT* CVariant::ElementAt (int iElement)
{
    if((vt == VT_VARIANT))
    {
        return pvarVal;
    }
    if((!(vt & VT_ARRAY)))
    {
        return this;
    }
    int      offset = iElement - parray->rgsabound[0].lLbound;
// Offset must be zero or greater and less than the bounds
    if (offset >= 0 && offset <= int(parray->rgsabound[0].cElements))
        return &((VARIANT *) parray->pvData)[offset];
    else
        return (VARIANT *) NULL;
}


_TCHAR* CVariant::ToString (int iElement)
{
    VARIANT*  v = ElementAt(iElement);
    if((v != (VARIANT*)NULL && v->vt == VT_BSTR))
    {
        return (_TCHAR*)v->bstrVal;
    }
    return NUL;
}


int CVariant::ToInt (int iElement)
{
    VARIANT*  v = ElementAt(iElement);
    if((v != (VARIANT*)NULL))
    {
        if(v->vt == VT_I1 )
        {
            return (int)v->bVal;
        }
        if(v->vt == VT_I2 )
        {
            return (int)v->iVal;
        }
        if(v->vt == VT_I4 )
        {
            return (int)v->lVal;
        }
    }
    return 0;
}


BOOL CVariant::ToBool (int iElement)
{
    VARIANT*  v = ElementAt(iElement);
    if((v != (VARIANT*)NULL))
    {
        if((v->vt == VT_BOOL))
        {
            return v->boolVal;
        }
        else
        {
            return FALSE;
        }
    }
    return FALSE;
}


void CVariant::Set (_TCHAR* szString, int iElement)
{
    VARIANT*  v = ElementAt(iElement);
    if((v != (VARIANT*)NULL))
    {
        v->vt = VT_BSTR;
        v->bstrVal = SysAllocString( szString);
    }
}


void CVariant::Set (int iValue, int iElement)
{
    VARIANT*  v = ElementAt(iElement);
    if((v != (VARIANT*)NULL))
    {
        v->vt = VT_I4;
        v->lVal = iValue;
    }
}


void CVariant::Set (VARIANT_BOOL  bValue, int iElement)
{
    VARIANT*  v = ElementAt(iElement);
    if((v != (VARIANT*)NULL))
    {
        v->vt = VT_BOOL;
        v->lVal = bValue;
    }
}


int IsReservedWord (cBcxDic&  oDic, const _TCHAR*  sWord)
{
    static int      Loaded;
    int      i = {0};
    if(Loaded == 0 )
    {
        while(str_cmp(DATA[i], _T("EOD")) != 0)
        {
            oDic.Add((_TCHAR*)DATA[i], _T(""));
            i++;
        }

        Loaded = 1;
    }
    if(oDic.Exists(ucase(sWord)))
    {
        return 1;
    }
    return 0;
}


int _tmain ()
{
    cBcxDic*  oDic;
    int      RetVal = {0};
    int      i = {0};
    double   t = {0};
    OleInitialize(NULL);
    oDic = new  cBcxDic;
    if(!oDic )
    {
        _tprintf(_T("%ls\n"), _T("No oDic allocation"));
        Pause();
        return EXIT_FAILURE;
    }
    t = timer();
    for(i = 1; i <= 1000000; i += 1)
    {
        RetVal = IsReservedWord(* oDic, _T("waitkey$"));
    }

    t = timer() - t;
    delete oDic;
    OleUninitialize();
    _tprintf(_T("%ls%.15G\n"), _T("t = "), (double)t);
    _tprintf(_T("%ls%d\n"), _T("RetVal = "), (int)RetVal);
    Pause();
    return RetVal;
}


class CVariant;

